// IWYU pragma: private, include "nvim/autocmd_defs.h"

typedef enum auto_event {
  EVENT_BUFADD = 0,
  EVENT_BUFCREATE = 1,
  EVENT_BUFDELETE = 2,
  EVENT_BUFENTER = 3,
  EVENT_BUFFILEPOST = 4,
  EVENT_BUFFILEPRE = 5,
  EVENT_BUFHIDDEN = 6,
  EVENT_BUFLEAVE = 7,
  EVENT_BUFMODIFIEDSET = 8,
  EVENT_BUFNEW = 9,
  EVENT_BUFNEWFILE = 10,
  EVENT_BUFREAD = 11,
  EVENT_BUFREADCMD = 12,
  EVENT_BUFREADPOST = 13,
  EVENT_BUFREADPRE = 14,
  EVENT_BUFUNLOAD = 15,
  EVENT_BUFWINENTER = 16,
  EVENT_BUFWINLEAVE = 17,
  EVENT_BUFWIPEOUT = 18,
  EVENT_BUFWRITE = 19,
  EVENT_BUFWRITECMD = 20,
  EVENT_BUFWRITEPOST = 21,
  EVENT_BUFWRITEPRE = 22,
  EVENT_CHANINFO = 23,
  EVENT_CHANOPEN = 24,
  EVENT_CMDLINECHANGED = 25,
  EVENT_CMDLINEENTER = 26,
  EVENT_CMDLINELEAVE = 27,
  EVENT_CMDUNDEFINED = 28,
  EVENT_CMDWINENTER = 29,
  EVENT_CMDWINLEAVE = 30,
  EVENT_COLORSCHEME = 31,
  EVENT_COLORSCHEMEPRE = 32,
  EVENT_COMPLETECHANGED = 33,
  EVENT_COMPLETEDONE = 34,
  EVENT_COMPLETEDONEPRE = 35,
  EVENT_CURSORHOLD = 36,
  EVENT_CURSORHOLDI = 37,
  EVENT_CURSORMOVED = 38,
  EVENT_CURSORMOVEDC = 39,
  EVENT_CURSORMOVEDI = 40,
  EVENT_DIAGNOSTICCHANGED = 41,
  EVENT_DIFFUPDATED = 42,
  EVENT_DIRCHANGED = 43,
  EVENT_DIRCHANGEDPRE = 44,
  EVENT_ENCODINGCHANGED = 45,
  EVENT_EXITPRE = 46,
  EVENT_FILEAPPENDCMD = 47,
  EVENT_FILEAPPENDPOST = 48,
  EVENT_FILEAPPENDPRE = 49,
  EVENT_FILECHANGEDRO = 50,
  EVENT_FILECHANGEDSHELL = 51,
  EVENT_FILECHANGEDSHELLPOST = 52,
  EVENT_FILEENCODING = 53,
  EVENT_FILEREADCMD = 54,
  EVENT_FILEREADPOST = 55,
  EVENT_FILEREADPRE = 56,
  EVENT_FILETYPE = 57,
  EVENT_FILEWRITECMD = 58,
  EVENT_FILEWRITEPOST = 59,
  EVENT_FILEWRITEPRE = 60,
  EVENT_FILTERREADPOST = 61,
  EVENT_FILTERREADPRE = 62,
  EVENT_FILTERWRITEPOST = 63,
  EVENT_FILTERWRITEPRE = 64,
  EVENT_FOCUSGAINED = 65,
  EVENT_FOCUSLOST = 66,
  EVENT_FUNCUNDEFINED = 67,
  EVENT_GUIENTER = 68,
  EVENT_GUIFAILED = 69,
  EVENT_INSERTCHANGE = 70,
  EVENT_INSERTCHARPRE = 71,
  EVENT_INSERTENTER = 72,
  EVENT_INSERTLEAVE = 73,
  EVENT_INSERTLEAVEPRE = 74,
  EVENT_LSPATTACH = 75,
  EVENT_LSPDETACH = 76,
  EVENT_LSPNOTIFY = 77,
  EVENT_LSPPROGRESS = 78,
  EVENT_LSPREQUEST = 79,
  EVENT_LSPTOKENUPDATE = 80,
  EVENT_MENUPOPUP = 81,
  EVENT_MODECHANGED = 82,
  EVENT_OPTIONSET = 83,
  EVENT_QUICKFIXCMDPOST = 84,
  EVENT_QUICKFIXCMDPRE = 85,
  EVENT_QUITPRE = 86,
  EVENT_RECORDINGENTER = 87,
  EVENT_RECORDINGLEAVE = 88,
  EVENT_REMOTEREPLY = 89,
  EVENT_SAFESTATE = 90,
  EVENT_SEARCHWRAPPED = 91,
  EVENT_SESSIONLOADPOST = 92,
  EVENT_SESSIONWRITEPOST = 93,
  EVENT_SHELLCMDPOST = 94,
  EVENT_SHELLFILTERPOST = 95,
  EVENT_SIGNAL = 96,
  EVENT_SOURCECMD = 97,
  EVENT_SOURCEPOST = 98,
  EVENT_SOURCEPRE = 99,
  EVENT_SPELLFILEMISSING = 100,
  EVENT_STDINREADPOST = 101,
  EVENT_STDINREADPRE = 102,
  EVENT_SWAPEXISTS = 103,
  EVENT_SYNTAX = 104,
  EVENT_TABCLOSED = 105,
  EVENT_TABENTER = 106,
  EVENT_TABLEAVE = 107,
  EVENT_TABNEW = 108,
  EVENT_TABNEWENTERED = 109,
  EVENT_TERMCHANGED = 110,
  EVENT_TERMCLOSE = 111,
  EVENT_TERMENTER = 112,
  EVENT_TERMLEAVE = 113,
  EVENT_TERMOPEN = 114,
  EVENT_TERMREQUEST = 115,
  EVENT_TERMRESPONSE = 116,
  EVENT_TEXTCHANGED = 117,
  EVENT_TEXTCHANGEDI = 118,
  EVENT_TEXTCHANGEDP = 119,
  EVENT_TEXTCHANGEDT = 120,
  EVENT_TEXTYANKPOST = 121,
  EVENT_UIENTER = 122,
  EVENT_UILEAVE = 123,
  EVENT_USER = 124,
  EVENT_VIMENTER = 125,
  EVENT_VIMLEAVE = 126,
  EVENT_VIMLEAVEPRE = 127,
  EVENT_VIMRESIZED = 128,
  EVENT_VIMRESUME = 129,
  EVENT_VIMSUSPEND = 130,
  EVENT_WINCLOSED = 131,
  EVENT_WINENTER = 132,
  EVENT_WINLEAVE = 133,
  EVENT_WINNEW = 134,
  EVENT_WINRESIZED = 135,
  EVENT_WINSCROLLED = 136,
  NUM_EVENTS = 137,
} event_T;
